#include "WrappedGeometry.hpp"

#include <algorithm>

WrappedGeometry::WrappedGeometry( const ftkGeometry& geom )
  : ftkGeometry( geom )
{}

unsigned int WrappedGeometry::getVersion() const
{
    return version;
}

void WrappedGeometry::setVersion( unsigned int value )
{
    version = ( value & 0xFF );
}

unsigned int WrappedGeometry::getPointsCount() const
{
    return pointsCount;
}

void WrappedGeometry::setPointsCount( unsigned int value )
{
    pointsCount = ( value & 0xFFFFFF );
}


PointsInGeom WrappedGeometry::getPositions() const
{
    PointsInGeom result;
    for ( uint32 i( 0u ); i < pointsCount; ++i )
    {
        result.emplace_back( positions[ i ].x, positions[ i ].y, positions[ i ].z );
    }
    return result;
}

void WrappedGeometry::setPositions( const PointsInGeom& value )
{
  for ( size_t i( 0u ); i < std::min( size_t( pointsCount ), value.size() ); ++i )
  {
      positions[ i ] = value.at( i );
  }
}
