#pragma once

#include "WrappedPoint.hpp"

#include <ftkInterface.h>


class WrappedGeometry : public ftkGeometry
{
public:
    WrappedGeometry() = default;
    WrappedGeometry( const WrappedGeometry& other ) = default;
    WrappedGeometry( WrappedGeometry&& other ) = default;
    WrappedGeometry( const ftkGeometry& geom );
    ~WrappedGeometry() = default;
    WrappedGeometry& operator=( const WrappedGeometry& other ) = default;
    WrappedGeometry& operator=( WrappedGeometry&& other ) = default;

    unsigned int getVersion() const;
    void setVersion( unsigned int value );
    unsigned int getPointsCount() const;
    void setPointsCount( unsigned int value );
    PointsInGeom getPositions() const;
    void setPositions( const PointsInGeom& value );
};
